/*
 * id.c
 *
 * Copyright (C) 2009 BLADOX, s.r.o.
 *
 */

#include <config.h>
#include <turbo/turbo.h>

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/*
TODO:
	- view @ in email (use UCS)
*/


/* *INDENT-OFF* */

lc_char PROGMEM lc_ID[]={ 
	LC_EN("ID")
	LC_END
};

lc_char PROGMEM lc_Lock[]={
	LC_EN("Lock")
	LC_END
};

lc_char PROGMEM lc_Unlock[]={ 
	LC_EN("Unlock")
	LC_END
};

lc_char PROGMEM lc_Autolock[]={ 
	LC_EN("One Use")
	LC_END
};

lc_char PROGMEM lc_Is_Lock[]={
	LC_EN(" is LOCKED")
	LC_END
};

lc_char PROGMEM lc_Is_Unlock[]={ 
	LC_EN(" is UNLOCKED")
	LC_END
};

lc_char PROGMEM lc_Is_Autolock[]={ 
	LC_EN(" is ONE TIME UNLOCKED")
	LC_END
};

lc_char PROGMEM lc_New[]={ 
	LC_EN("New ID")
	LC_END
};

lc_char PROGMEM lc_Select[]={ 
	LC_EN("Select")
	LC_END
};

lc_char PROGMEM lc_View[]={ 
	LC_EN("View")
	LC_END
};

lc_char PROGMEM lc_Delete[]={ 
	LC_EN("Delete")
	LC_END
};

lc_char PROGMEM lc_Enter_PIN[]={
	LC_EN("Enter PIN:")
	LC_END
};

lc_char PROGMEM lc_Error_Wrong_PIN[]={
	LC_EN("Error: Wrong PIN")
	LC_END
};

lc_char PROGMEM lc_Error_No_App[]={
	LC_EN("Error: No ID Application Installed")
	LC_END
};

lc_char PROGMEM lc_ID_ID[]={ 
	LC_EN("ID: ")
	LC_END
};

lc_char PROGMEM lc_ID_User[]={ 
	LC_EN("User: ")
	LC_END
};

lc_char PROGMEM lc_ID_Passwd[]={ 
	LC_EN("Password: ")
	LC_END
};

lc_char PROGMEM lc_ID_OTP[]={ 
	LC_EN("OTP Key: ")
	LC_END
};

lc_char PROGMEM lc_ID_Name[]={ 
	LC_EN("Name: ")
	LC_END
};

lc_char PROGMEM lc_ID_Addr[]={ 
	LC_EN("Address: ")
	LC_END
};

lc_char PROGMEM lc_ID_Email[]={ 
	LC_EN("Email: ")
	LC_END
};

/* *INDENT-ON* */

#define MIN_PIN_LEN	8
#define MAX_PIN_LEN	8

typedef struct _Pers_mem
{
  SEdge *ids;			// pointer to eeprom to key list
  SNode *active;
}
Pers_mem;

Pers_mem *pers_mem;
u8 onleave;
SEdge *onleave_edge;
SNode *onleave_node;

u8 PROGMEM t_apdu_select[] =
  { 0x00, 0xA4, 0x04, 0x00, 0x0A, 0xA0, 0x00, 0x00, 0x00, 0x62, 0x03, 0x01,
  0x0D, 0x01, 0x01, 0x00
};

#define DEF_NO_ID		0x7f

#define DEF_ERR_NO		0x00
#define DEF_ERR_NO_APP		0x01
#define DEF_ERR_WRONG_PIN	0x02

#define DEF_SE_SELECT		0x00
#define DEF_SE_UNLOCK		0x20
#define DEF_SE_GET_STATE	0x21
#define DEF_SE_SET_STATE	0x22
#define DEF_SE_GET_FREE_ID	0x23
#define DEF_SE_SET_SELECTED_ID	0x24
#define DEF_SE_GET_ID		0x25
#define DEF_SE_SET_ID		0x26

#define DEF_ONLEAVE_AUTOLOCK 	0
#define DEF_ONLEAVE_UNLOCK 	1
#define DEF_ONLEAVE_LOCK 	2

#define DEF_TAG_USED		0x00
#define DEF_TAG_UID		0x01
#define DEF_TAG_PASS		0x02
#define DEF_TAG_OTP		0x03
#define DEF_TAG_NAME		0x04
#define DEF_TAG_ADDR		0x05
#define DEF_TAG_EMAIL		0x06

u8 xtwin_t1_apdu (u8 l, u8 * buf)
{
  u8 i;

  dbsp ("TWIN: ");
  dbch (l);
  dbc ('\n');
  for (i = 0; i < l; i++)
  {
    dbch (buf[i]);
    dbc (' ');
  }
  dbc ('\n');

  buf[0] = 0;
  buf[1] = 0;
  buf[2] = 0;
  buf[3] = 0x90;
  buf[4] = 0x00;
  buf[5] = 0;
  return 6;
}

u16 se_action (u8 action, u8 id, u8 tag, u8 * l, u8 * data)
{
  u8 *a = buf_A ();
  u8 i, j;
  u16 ret;

  dbsp ("SE_ACTION ");
  dbch (*l);
  dbc ('\n');
  for (i = 0; i < *l; i++)
  {
    dbch (data[i]);
    dbc (' ');
  }
  dbc ('\n');

/*
  *l = 1;
  data[0] = '\0';
  return 0x9000;
*/

  if (action != DEF_SE_SELECT)
  {
    twin_clk_on ();

    a[0] = 0x80;
    a[1] = action;
    a[2] = id;
    a[3] = tag;
    j = *l;
    a[4] = j;
// TODO only of SET actions
    memcpy (&a[5], data, j);
    j += 5;
    j = twin_t1_apdu (j, a);
  }
  else
  {
    twin_on (NULL);
    memcpy (a, t_apdu_select, sizeof (t_apdu_select));
    j = twin_t1_apdu (sizeof (t_apdu_select), a);
  }

  ret = a[j - 3];
  ret <<= 8;
  ret |= a[j - 2];

#define D_OFF   3
  j = j - D_OFF - 3;
// don't use memcpy - we need to copy from left for overlapping bufs
  for (i = 0; i < j; i++)
    data[i] = a[D_OFF + i];
  data[i] = '\0';		// helper for strings
  *l = j;			// raw data returned, without SW1SW2

  twin_clk_off ();
  return ret;
}

SNodeP menu_select_n;
SNodeP menu_view_n;
SNodeP menu_delete_n;
extern SNodeP menu_n;

u8 id_ctx (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    spider_append_r (ctx, &menu_delete_n);
    spider_append_r (ctx, &menu_view_n);
    spider_append_r (ctx, &menu_select_n);
  }
  else if (action == APP_LEAVE)
  {
    spider_clear_r (ctx);
  }
  return APP_OK;
}

u8 menu_new (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *res;
    u8 i, j, k;
    SEdge *e = NULL;
    SNode *n = NULL;
    u8 *n_text = NULL;
    u8 *text = NULL;
    u8 *buf = buf_B ();
    u8 id;

    i = 0;
    se_action (DEF_SE_GET_FREE_ID, 0, 0, &i, buf);
    id = buf[0];
    if (id == DEF_NO_ID)
      goto X_ERR;

    n = emalloc (sizeof (SNode));
    if (n == NULL)
      goto X_ERR;

    e = emalloc (sizeof (SEdge));
    if (e == NULL)
      goto X_ERR;

    res = get_input (locale (lc_ID_ID), 1, 12, NULL, Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
    {
      i = APP_END;
      goto X_END;
    }
    if (res == NULL)
    {
      i = APP_BACK;
      goto X_END;
    }

    n_text = emalloc (res[0] + 1);
    if (n_text == NULL)
      goto X_ERR;

    memcpy (&n_text[1], res + 2, res[0] - 1);
    wb (&n_text[0], ' ');
    wb (n_text + res[0], '\0');

#define MAX_TAG_UID	15
#define MIN_TAG_UID	1
#define MAX_TAG_PASS	15
#define MIN_TAG_PASS	1
#define MAX_TAG_OTP	6
#define MIN_TAG_OTP	6
#define MAX_TAG_NAME	30
#define MIN_TAG_NAME	1
#define MAX_TAG_ADDR	50
#define MIN_TAG_ADDR	1
#define MAX_TAG_EMAIL	30
#define MIN_TAG_EMAIL	5

    res =
      get_input (locale (lc_ID_User), MIN_TAG_UID, MAX_TAG_UID, NULL,
		 Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
    {
      i = APP_END;
      goto X_END;
    }
    if (res == NULL)
    {
      i = APP_BACK;
      goto X_END;
    }
    i = res[0] - 1;
    memcpy (buf, &res[2], i);
    se_action (DEF_SE_SET_ID, id, DEF_TAG_UID, &i, buf);

    res =
      get_input (locale (lc_ID_Passwd), MIN_TAG_PASS, MAX_TAG_PASS, NULL,
		 Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
    {
      i = APP_END;
      goto X_END;
    }
    if (res == NULL)
    {
      i = APP_BACK;
      goto X_END;
    }
    i = res[0] - 1;
    memcpy (buf, &res[2], i);
    se_action (DEF_SE_SET_ID, id, DEF_TAG_PASS, &i, buf);

    res =
      get_input (locale (lc_ID_OTP), MIN_TAG_OTP, MAX_TAG_OTP, NULL,
		 Q_GET_INPUT_DIGITS);
    if (res == ENULL)
    {
      i = APP_END;
      goto X_END;
    }
    if (res == NULL)
    {
      i = APP_BACK;
      goto X_END;
    }
    i = res[0] - 1;
    memcpy (buf, &res[2], i);
    se_action (DEF_SE_SET_ID, id, DEF_TAG_OTP, &i, buf);

    res =
      get_input (locale (lc_ID_Name), MIN_TAG_NAME, MAX_TAG_NAME, NULL,
		 Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
    {
      i = APP_END;
      goto X_END;
    }
    if (res == NULL)
    {
      i = APP_BACK;
      goto X_END;
    }
    i = res[0] - 1;
    memcpy (buf, &res[2], i);
    se_action (DEF_SE_SET_ID, id, DEF_TAG_NAME, &i, buf);

    res =
      get_input (locale (lc_ID_Addr), MIN_TAG_ADDR, MAX_TAG_ADDR, NULL,
		 Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
    {
      i = APP_END;
      goto X_END;
    }
    if (res == NULL)
    {
      i = APP_BACK;
      goto X_END;
    }
    i = res[0] - 1;
    memcpy (buf, &res[2], i);
    se_action (DEF_SE_SET_ID, id, DEF_TAG_ADDR, &i, buf);

    res =
      get_input (locale (lc_ID_Email), MIN_TAG_EMAIL, MAX_TAG_EMAIL, NULL,
		 Q_GET_INPUT_ALPHABET);
    if (res == ENULL)
    {
      i = APP_END;
      goto X_END;
    }
    if (res == NULL)
    {
      i = APP_BACK;
      goto X_END;
    }
    i = res[0] - 1;
    memcpy (buf, &res[2], i);
    se_action (DEF_SE_SET_ID, id, DEF_TAG_EMAIL, &i, buf);

// TODO if first->select

    ww (&n->p, id);
    ww (&n->text, n_text);
    ww (&n->cb, id_ctx);

    ww (&e->f, &menu_n);
    ww (&e->t, n);
    wb (&e->source, MEM_F_P | MEM_T_E);

// TODO insert sorted
    ww (&e->next, rw (&pers_mem->ids));
    ww (&pers_mem->ids, e);

    i = 1;
    buf[0] = 1;			// used
    se_action (DEF_SE_SET_ID, id, DEF_TAG_USED, &i, buf);

    return APP_BACK;
  X_ERR:
    i = APP_OK;
  X_END:
    efree (e);
    efree (n);
    efree (n_text);
    free (buf);

    if (i == APP_OK)
      perror (ERR_NO_EEPROM);
    return i;
  }

  return APP_OK;
}

u8 menu_view (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    SNode *n = ctx->parent->f;
    u8 id = rw (&n->p);
    u8 j = 1;
    u8 i, k;
    u8 *buf = buf_B ();
    u8 *a = buf_A ();
    u8 *r = buf;

    r = sprints (r, locale (lc_ID_ID));
    k = 0;
    se_action (DEF_SE_GET_ID, id, DEF_TAG_UID, &k, a);
    r = sprints (r, a);
    r = sprintc (r, '\n');

    r = sprints (r, locale (lc_ID_Passwd));
    k = 0;
    se_action (DEF_SE_GET_ID, id, DEF_TAG_PASS, &k, a);
    r = sprints (r, a);
    r = sprintc (r, '\n');

    r = sprints (r, locale (lc_ID_OTP));
    k = 0;
    se_action (DEF_SE_GET_ID, id, DEF_TAG_OTP, &k, a);
    r = sprints (r, a);
    r = sprintc (r, '\n');

    r = sprints (r, locale (lc_ID_Name));
    k = 0;
    se_action (DEF_SE_GET_ID, id, DEF_TAG_NAME, &k, a);
    r = sprints (r, a);
    r = sprintc (r, '\n');

    r = sprints (r, locale (lc_ID_Addr));
    k = 0;
    se_action (DEF_SE_GET_ID, id, DEF_TAG_ADDR, &k, a);
    r = sprints (r, a);
    r = sprintc (r, '\n');

    r = sprints (r, locale (lc_ID_Email));
    k = 0;
    se_action (DEF_SE_GET_ID, id, DEF_TAG_EMAIL, &k, a);
    r = sprints (r, a);
    r = sprintc (r, '\n');

    r = sprintc (r, '\0');
    return display_text (buf, NULL);
  }

  return APP_OK;
}

u8 menu_delete (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res;
    u8 i;
    SNode *n = ctx->parent->f;
    u8 id = rw (&n->p);
    u8 *buf = buf_B ();
    u8 *r;

    res = yesno (rw (&n->text), Q_YESNO_DELETE_QMARK, 0);
    if (res == APP_END)
      return APP_END;
    if (res == APP_YES)
    {
      SEdge *e = rw (&pers_mem->ids);
      SEdge *f = e;
      u8 id;

      i = 1;
      buf[0] = 0;		// used
      se_action (DEF_SE_SET_ID, id, DEF_TAG_USED, &i, buf);

      while (e)
      {
	if (rw (&e->t) == n)
	  break;
	f = e;
	e = rw (&e->next);
      }

      if (e == rw (&pers_mem->ids))
	ww (&pers_mem->ids, rw (&e->next));
      else
	ww (&f->next, rw (&e->next));

      if (n == rw (&pers_mem->active))
      {
	f = rw (&pers_mem->ids);
	if (f)
	{
	  n = rw (&f->t);
	  buf = rw (&n->text);
	  wb (&buf[0], '*');
	  ww (&pers_mem->active, n);
	  id = rw (&n->p);
	}
	else
	{
	  ww (&pers_mem->active, NULL);
	  id = DEF_NO_ID;	// no identity
	}

	r = buf_B ();
	i = 1;
	r[0] = id;
	se_action (DEF_SE_SET_SELECTED_ID, 0, 0, &i, r);
      }

      efree (e);
      efree (rw (&n->text));
      efree (n);
      spider_back (ctx);
    }
    return APP_BACK;
  }

  return APP_OK;
}

u8 menu_select (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 res;
    SNode *n = ctx->parent->f;
    SEdge *e = rw (&pers_mem->ids);
    SNode *cn = rw (&pers_mem->active);
    u8 *r;
    u8 i;
    u8 id = rw (&n->p);

    if (cn != n)
    {
      if (cn)
      {
	r = rw (&cn->text);
	wb (&r[0], ' ');
      }
      r = rw (&n->text);
      wb (&r[0], '*');
      ww (&pers_mem->active, n);

      r = buf_B ();
      i = 1;
      r[0] = id;
      se_action (DEF_SE_SET_SELECTED_ID, 0, 0, &i, r);
    }

    spider_back (ctx);

    return APP_BACK;
  }

  return APP_OK;
}

u8 onleave_cb (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    onleave++;
    if (onleave > 2)
      onleave = 0;
    return APP_BACK;
  }

  return APP_OK;
}

u8 menu_main (SCtx * ctx, u8 action)
{
  if (action == APP_ENTER)
  {
    u8 *s;
    u8 *d = onleave_node->text;
    u8 *l;

    ctx->eE = rw (&pers_mem->ids);
    ctx->eR = onleave_edge;
    switch (onleave)
    {
      case DEF_ONLEAVE_AUTOLOCK:
	s = locale (lc_Autolock);
	break;
      case DEF_ONLEAVE_LOCK:
	s = locale (lc_Lock);
	break;
      case DEF_ONLEAVE_UNLOCK:
	s = locale (lc_Unlock);
	break;
    }
    l = strlen (s) + 1;
    memcpy (d, s, l);
  }
  else if (action == APP_LEAVE)
  {
    ctx->eE = NULL;
    ctx->eR = NULL;
  }
  return APP_OK;
}

SNodeP menu_n = { lc_ID, menu_main };
SNodeP menu_new_n = { lc_New, menu_new };
SNodeP menu_select_n = { lc_Select, menu_select };
SNodeP menu_view_n = { lc_View, menu_view };
SNodeP menu_delete_n = { lc_Delete, menu_delete };

/* *INDENT-OFF* */

SEdgeP menu_edges_p[] = {
  {&menu_n, &menu_new_n},
  NULL
};

/* *INDENT-ON* */

void menu_action (void *x)
{
  SCtx *c;
  u8 i, l;
  u16 ret;
  u8 *res;
  u8 err = NO_ERROR;
  u8 *buf = buf_B ();
  u8 *t;

  ret = se_action (DEF_SE_SELECT, 0, 0, &i, buf);
  if (ret != 0x9000)
  {
    display_text (locale (lc_Error_No_App), NULL);
    goto X_ERR;
  }

  res =
    get_input (locale (lc_Enter_PIN), MIN_PIN_LEN, MAX_PIN_LEN, NULL,
	       Q_GET_INPUT_DIGITS);
  if (res == NULL || res == ENULL)
    goto X_ERR;

  l = res[0] - 1;
  l = l / 2;
  for (i = 0; i < l; i++)
    buf[i] = ((res[2 + i * 2] - '0') << 4) | ((res[2 + i * 2 + 1]) - '0');

  ret = se_action (DEF_SE_UNLOCK, 0, 0, &l, buf);
  if (ret != 0x9000)
  {
    display_text (locale (lc_Error_Wrong_PIN), NULL);
    goto X_ERR;
  }

  l = 0;
  se_action (DEF_SE_GET_STATE, 0, 0, &l, buf);
  onleave = buf[0];
  if (onleave == DEF_ONLEAVE_AUTOLOCK || onleave == DEF_ONLEAVE_UNLOCK)
    onleave = DEF_ONLEAVE_LOCK;
  else
    onleave = DEF_ONLEAVE_AUTOLOCK;

  c = spider_init ();
  if (c != NULL)
  {
    buf = malloc (20);
    onleave_node = malloc (sizeof (SNode));
    onleave_node->cb = onleave_cb;
    onleave_node->text = buf;

    onleave_edge = malloc (sizeof (SEdge));
    onleave_edge->next = NULL;
    onleave_edge->f = &menu_n;
    onleave_edge->t = onleave_node;
    onleave_edge->source = MEM_F_P | MEM_T_R;

    c->n = &menu_n;
    c->eP = &menu_edges_p;
    spider_set_order (c, ORDER_R, ORDER_P, ORDER_E, ORDER_D);
    spider (c);

    free (buf);
    free (onleave_edge);
    free (onleave_node);

    l = 1;
    buf[0] = onleave;
    se_action (DEF_SE_SET_STATE, 0, 0, &l, buf);

    SNode *n = rw (&pers_mem->active);

    if (n)
    {
      t = rw (&n->text);
      t++;			// skip * or ' '

      res = buf;
      res = sprints (res, t);
      switch (onleave)
      {
	case DEF_ONLEAVE_AUTOLOCK:
	  res = sprints (res, locale (lc_Is_Autolock));
	  break;
	case DEF_ONLEAVE_LOCK:
	  res = sprints (res, locale (lc_Is_Lock));
	  break;
	case DEF_ONLEAVE_UNLOCK:
	  res = sprints (res, locale (lc_Is_Unlock));
	  break;
      }
      res = sprintc (res, '\0');
      display_text (buf, NULL);
    }
  }
  else
    err = ERR_NO_RAM;

X_ERR:
  twin_off ();
  if (err != NO_ERROR)
    perror (err);
}

u8 PROGMEM t_BLADOX[] = "BLADOX";

void turbo_handler (u8 action, void *data)
{
  switch (action)
  {
    case ACTION_APP_REGISTER:
      {
	Pers_mem *p = emalloc (sizeof (Pers_mem));

	if (p)
	{
	  ww (&p->ids, NULL);
	  ww (&p->active, NULL);
	  reg_app_data (p);
	}
      }
      break;

    case ACTION_APP_UNREGISTER:
      {
	Pers_mem *p = app_data ();
	SEdge *e, *f;
	SNode *n;
	u8 *t;

	e = rw (&p->ids);
	while (e)
	{
	  n = rw (&e->t);
	  t = rw (&n->text);
	  efree (t);
	  efree (n);
	  f = rw (&e->next);
	  efree (e);
	  e = f;
	}
	efree (p);
      }
      break;

    case ACTION_INSERT_MENU:
      set_menu_alpha (t_BLADOX);
      insert_menu (locale (lc_ID));
      break;

    case ACTION_MENU_SELECTION:
      stk_thread (menu_action, NULL);
      break;

    case ACTION_APP_INIT:
      pers_mem = app_data ();
      break;

    default:
      break;
  }
}
